CodeForces 295B

/*从要删除最后一个到第一个进行松弛操作, 因为如果从第一个到最后一个进行松弛操作,弟24行有可能不会更新,若要更新,就需要再一次对d[N][N]初始化*/ 

 1 #include <iostream>
 2 #include <cstdio>
 3 using namespace std;
 4 typedef long long ll;
 5 #define N 505
 6 //const int  inf=1<<30;
 7 ll  d[N][N],dis[N];
 8 int del[N];
 9 bool v[N];
10 int main(){
11     int n,i,j,l;
12     scanf("%d",&n);
13     for(int i=0;i<n;i++){
14         for(int j=0;j<n;j++){
15             cin>>d[i][j];
16         }
17     }
18     for(i=0;i<n;i++){cin>>del[i];del[i]-=1;}
19     for(i=n-1;i>=0;i--){
20         v[del[i]]=1;
21         ll k=0;
22         for(j=0;j<n;j++){
23             for(l=0;l<n;l++){
24                 d[j][l]=min(d[j][l],d[j][del[i]]+d[del[i]][l]);
25             }
26         }
27         for(j=0;j<n;j++){
28             for(l=0;l<n;l++){
29                 if(v[l]&&v[j]){
30                     k+=d[j][l];
31                 }
32             }
33         }
34         dis[i]=k;
35     }
36     for(i=0;i<n-1;i++)cout<<dis[i]<<" ";
37     cout<<dis[n-1]<<endl;
38     return 0;
39 }

CodeForces 295B

时间: 2024-10-10 07:14:09

CodeForces 295B的相关文章

Problem B Codeforces 295B 最短路(floyd)

Description Greg has a weighed directed graph, consisting of n vertices. In this graph any pair of distinct vertices has an edge between them in both directions. Greg loves playing with the graph and now he has invented a new game: The game consists

codeforces 295B B. Greg and Graph(floyd+dp)

题目链接: codeforces 295B 题目大意: 给出n个点的完全有权有向图,每次删去一个点,求每次操作前整张图各个点的最短路之和. 题目分析: 首先删边对于我们来说是不好做的,所以我们想到了通过加点的方式逆向地做,那么加点怎么做呢? 其实就是一个我们很熟悉的算法:floyd,因为我们通常用的都是它的简化版本,所以可能很多人并不理解它的确切的思想. 在介绍这道题的具体解法之前,我先解释一下floyd,可能之后的问题就迎刃而解了. 首先floyd其实是动态规划,没有省略时的状态是这样定义的.

Codeforces 295B Greg and Graph

题意:给你一个完全图,给你删点顺序,问你这些点删除前 整个图的最短路的和. 解题思路:这其实是floyd-warshall 算法的 一个应用.我们可以从最后一个点开始 ,对他的顺序进行映射,题意就正好符合floyd 的定义. 解题代码: 1 // File Name: 295b.cpp 2 // Author: darkdream 3 // Created Time: 2015年03月11日 星期三 19时13分13秒 4 5 #include<vector> 6 #include<li

暑期测试训练3

1.Codeforces 20C spfa算法的简单题,在这个过程中多了一个记录连接最短路径上的前一个节点的位置的数组,然后将这个数组逆向输出 在这道题目中,我路径数组范围居然忘记*2了,结果一直报错,找了好久,%>_<% #include <iostream> #include <cstdio> #include <queue> #include <cstring> using namespace std; #define N 100010 #

CSU-ACM暑假集训基础组七夕专场

•Problem A Codeforces 20C       最短路(dij,spfa) •题意:给出一张n个点m条边的无向图 (2 ≤ n ≤ 105, 0 ≤ m ≤ 105),输出从1到n的任意一条最短路径. •解法:dijkstra或者spfa,用pre数组记录到达每个点最短距离的前驱结点. •注意:路径的长度范围是 1 ≤ wi ≤ 106,从1到n的最短路径长度可能超出int范围. •没有路径从1到达n时要输出-1 1 #include <cstdio> 2 #include &

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st